
registerComponent("chart_donut", "", "chart_donut", "chart_donut", "chart_donut_init", "chart_donut_resize", "chart_donut_refresh", "string:label:%,real:value:90:0:100,real:min:0:0:100,real:max:100:0:100,color:oncolor:0xFF0000FF,color:offcolor:0xFF000044,real:inner:0.8:0:0.9,string:main_style,string:caption,string:caption_style,bool:invert", "")
 
function chart_donut_init(width, height){
	// create a renderkit
	var rk = createComponent(self, "renderkit", 0, 0, 100, 100)
	// create two shapes
	renderkitShapeCreate(rk, "");
	renderkitShapeCreate(rk, "");
	
	//create the text for the amount
	var txt = createComponent(self, "text", 0, 30, 100, 50);
	setProperty(txt,"text",getData(self, "value") + getData(self,"label"));
	
	setProperty(txt,"resize_type", 2);
	setProperty(txt,"font_align", 1);
	setProperty(txt,"font_size", 8);
	setProperty(txt,"center_vertical", 1);
	
	//create the text for the label
	var txt2 = createComponent(self, "text", 0, 50, 100, 70);
	setProperty(txt2,"text",getData(self,"caption"));
	
	setProperty(txt2,"resize_type", 2);
	setProperty(txt2,"font_align", 1);
	setProperty(txt2,"font_size", 4);
	setProperty(txt2,"center_vertical", 1);
}
 
function chart_donut_resize(width, height){
	// get the renderkit and draw
	var rk = getComponentChild(self,0);
	chart_donut_draw(rk);
}
 
function chart_donut_refresh(width, height){
	//update the chart when you change any properties
	var rk = getComponentChild(self,0);
	chart_donut_draw(rk);
}
 
function chart_donut_draw(rk){
	if(rk){
		// check size of renderkit in local units
		var width = getProperty(rk, "width");
		var height = getProperty(rk, "height");
		var min = getData(self, "min");
		var max = getData(self, "max");
		if (max==min) max += 0.1;
		var value = getData(self, "value");
		var oncolor = getData(self, "oncolor");
		var offcolor = getData(self, "offcolor");
		var inner = getData(self, "inner");
		var invert = getData(self, "invert");
		var main_style = getData(self, "main_style");
		var caption_style = getData(self, "caption_style");
		
		// clear the shapes
		renderkitShapeClear(rk,0);
		renderkitShapeClear(rk,1);
		
		//setup for drawing
		renderkitShapeStrokeWidth(rk, 0, 0);
		renderkitShapeFilled(rk,0,true)
		renderkitShapeFillColor(rk,0,oncolor)

		renderkitShapeStrokeWidth(rk, 1, 0);
		renderkitShapeFilled(rk,1,true)
		renderkitShapeFillColor(rk,1,offcolor)
		
		var angle = ((value-min) / (max-min)) * 360 + 90
		var radius = width / 2.0;
		if (width>height) radius = height / 2.0;
		
		//draw the wedges for the donut control
		if (invert == 'true'){ //from the bottom
			renderkitShapeDoWedge(rk, 0, width / 2.0, height / 2.0, radius * inner, radius, 90, angle)
			renderkitShapeDoWedge(rk, 1, width / 2.0, height / 2.0, radius * inner, radius, angle, 450)
		}else{ //from the top
			renderkitShapeDoWedge(rk, 0, width / 2.0, height / 2.0, radius * inner, radius, -90, angle - 180)
			renderkitShapeDoWedge(rk, 1, width / 2.0, height / 2.0, radius * inner, radius, angle - 179.999, -90)
		}
		
		//update the text
		var txt = getComponentChild(self, 1);
		var cval = Number(getData(self, "value")).toFixed(0);
		var fntsize = 9
		setProperty(txt,"text", cval + getData(self,"label"));
		if (main_style.length>1){
			setTextStyle(txt, main_style)
			fntsize = getProperty(txt,"font_size");
		}
		
		//40 is a default radius size to compare the current radius size to.
		//scale_factor is proportional to the size of the circle.
		var scale_factor = radius / 40.0 
		setProperty(txt,"font_size", scale_factor * fntsize);
		var y_offset = ((radius*2)/height) * 20
		positionComponent(txt,0,50-y_offset,100,50);
		
		var txt2 = getComponentChild(self, 2);
		
		setProperty(txt2,"text", getData(self,"caption"));
		if (caption_style.length>1){
			setTextStyle(txt2, caption_style)
			fntsize = getProperty(txt2,"font_size");
		}
		setProperty(txt2,"font_size", scale_factor * fntsize);
		positionComponent(txt2,0,50,100,50+y_offset);
	}
}